stages:
  - build
  - test

docker:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "${CI_REGISTRY_USER}" -p "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"
  script:
    - docker build --pull -t "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}" .
    - docker push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
  rules:
    - if: $CI_COMMIT_TAG
      exists:
        - Dockerfile

kustomize:
  image: registry.gitlab.com/egeneralov/aio-bundle:4.3.0
  stage: build
  script:
    - cd config/manager && kustomize edit set image controller=${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG} && cd -
    - kustomize build ./config/default > "${CI_COMMIT_TAG}.yaml"
  rules:
    - if: $CI_COMMIT_TAG
  artifacts:
    paths:
      - "${CI_COMMIT_TAG}.yaml"
    expire_in: "1 year"

kubeval:
  image: registry.gitlab.com/egeneralov/aio-bundle:4.3.0
  stage: test
  script:
    - kubeval --strict --skip-kinds CustomResourceDefinition ${CI_COMMIT_TAG}.yaml
  needs:
    - kustomize
  rules:
    - if: $CI_COMMIT_TAG

kind:
  image: registry.gitlab.com/egeneralov/aio-bundle:4.4.0
  stage: test
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_CERTDIR: "/certs"
    DOCKER_TLS_VERIFY: 1
    DOCKER_CERT_PATH: "$DOCKER_TLS_CERTDIR/client"
  before_script:
    - kind create cluster --name $CI_PIPELINE_ID --wait 180s --config=ci/kind.yaml
    - kubectl cluster-info
    - kubectl -n kube-system rollout status deployment.apps/coredns --watch
    - kubectl -n kube-system rollout status daemonset.apps/kube-proxy --watch
    - kubectl -n kube-system rollout status daemonset.apps/kindnet --watch
    - kubectl -n local-path-storage rollout status deployment.apps/local-path-provisioner --watch
    - sleep 30
    - kubectl get nodes -o wide
  script:
    - kubectl apply -f "${CI_COMMIT_TAG}.yaml"
    - kubectl -n bitnami-system rollout status deployment.apps/bitnami-controller-manager --watch
    - kustomize build ./config/samples/ | kubectl apply -f -
  after_script:
    - kind delete cluster --name $CI_PIPELINE_ID
  needs:
    - kustomize
    - docker
  rules:
    - if: $CI_COMMIT_TAG
